= nng_http_req_set_uri(3http)
//
// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_http_req_set_uri - set HTTP request URI

== SYNOPSIS

[source, c]
----
#include <nng/nng.h>
#include <nng/supplemental/http/http.h>

int nng_http_req_set_uri(nng_http_req *req, const char *uri);
----

== DESCRIPTION

The `nng_http_req_set_uri()` sets the Request-URI associated with
the request _req_ to _uri_.
The _uri_ should contain precisely the
string that will be sent to the HTTP server in the request, including
any query information or fragment.

A local copy of the _uri_ is made in the request _req_.

NOTE: No validation or canonicalization of the _uri_ is performed.

TIP: The xref:nng_url_parse.3.adoc[`nng_url_parse()`] function can be used to
perform validation and canonicalization.
The `u_requri` member will
contain a suitable value that can be used with this function.

== RETURN VALUES

This function returns 0 on success, and non-zero otherwise.

== ERRORS

[horizontal]
`NNG_ENOMEM`:: Insufficient memory to perform the operation.
`NNG_ENOTSUP`:: No support for HTTP in the library.

== SEE ALSO

[.text-left]
xref:nng_http_req_alloc.3http.adoc[nng_http_req_alloc(3http)],
xref:nng_http_req_get_uri.3http.adoc[nng_http_req_get_uri(3http)],
xref:nng_url_parse.3.adoc[nng_url_parse(3)],
xref:nng.7.adoc[nng(7)]
